// A demonstration of a sliding object losing energy
// to friction, sliding to a stop.

float position = 0;
float speed = 10.0;
float friction = 0.1; 

void setup()
{
  size( 600, 100 );
}

void step()
{
  // Lose some speed due to friction
  speed = speed - friction;
  if( speed < 0.0 ) {
    speed = 0.0;
    noLoop();
  }
  // Update position using speed
  position = position + speed;
}

void draw()
{  
  // Run the physical simulation for
  // one step
  step();
  
  // Draw the world
  background( 80 );
  ellipse( position, 50, 50, 50 );
}